#include "UART.h"
//#include "J1939_Interface.h"
/********************************************************************
*
*
********************************************************************/
//unsigned char Received_Data;
unsigned char Keep_Transmitting;
/********************************************************************
*
*
********************************************************************/
/*void InterruptHandlerHigh (void);
/********************************************************************
* High priority interrupt vector
*
********************************************************************/
/*#pragma code InterruptVectorHigh = 0x0008
void InterruptVectorHigh( void )
{
  _asm
    goto InterruptHandlerHigh 
  _endasm
}
/********************************************************************
* High priority interrupt routine
*
********************************************************************/
/*#pragma code
#pragma interrupt InterruptHandlerHigh

void InterruptHandlerHigh( void )
{
	if (PIR1bits.RCIF)
	{
		Keep_Transmitting = FALSE;	// Stop transmission on new data
		Received_Data = RCREG;		// Save into a global variable
		PIR1bits.RCIF = 0;
	}
}
/********************************************************************
*
*
********************************************************************/
void Initialize_UART(void)
{
	//Keep_Transmitting = FALSE;
	//Received_Data = 0;

	TRISC = 0;
//	TRISCbits.TRISC6 = 0;

	TXSTA = 0x00;
//	TXSTAbits.TXEN = 1;		// Enable transmission

#if (BRGH_VALUE == 0)
	TXSTA,BRGH = 0;		// Low speed
#elif (BRGH_VALUE == 1)
	TXSTA,BRGH = 1;		// High speed
#endif

	RCSTA = 0x00;
	RCSTA,SPEN = 1;			// Enable serial
	RCSTA,CREN = 1;			// Enable Rx

//BAUDCON = 0x00;

	SPBRG = BAUD_RELOAD;

	//IPR1,RCIP = 1;			// UART as high priority
	PIE1,RCIE = 1;			// Enable interrupt for Rx

}
/********************************************************************
*
*
********************************************************************/
void SendToUart(unsigned char data)
{
   while(!(TXSTA,TRMT)); // loop till the previous character is transmitted
   TXREG = data;           // move data to TX- buffer
}

/*void interrupt_isr(void)
{
	if(RCIF == 1)
	{
		Received_Data= RCREG;
		PIR1,RCIF = 0;
		INTCON,GIE = 1;         
		INTCON,PEIE = 1;
	}
	if(PIR1,TXIF == 1)
	{
		PIR1,TXIF = 0;
		TXREG = Received_Data;
		INTCON,GIE = 1;         
		INTCON,PEIE = 1;
	}
	
}*/
void Initialize_UART1(void)
{
	TXSTA = 0x00;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
	TXSTA = 0x00;
	SPBRG = 0x1F;
	PIR1 = 0x00;
	//INTCON,GIE = 1;         
	//INTCON,PEIE = 1;        
	PIE1 = 0x30;
	RCSTA = 0x90;
	//usart_initialize1();
	//usart_initialize1();
	//TXREG = 'a';

	//INTCON = 0xC0;
}